package at.juggle.gdx;

import com.badlogic.gdx.ApplicationListener;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.InputAdapter;
import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.backends.openal.Wav;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.GL10;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.graphics.Color;

import java.awt.*;
import java.io.File;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: mlux
 * Date: 24.01.12
 * Time: 12:41
 * To change this template use File | Settings | File Templates.
 */
public class GdxTestGame extends InputAdapter implements ApplicationListener {
    SpriteBatch spriteBatch;
    Texture ship, bg;
    Vector2 shipPosition = new Vector2(36, 5);
    boolean moveLeft = false, moveRight = false;
    float moveShip = 0;
    float offset = 0f;
    Sound fire;
    Music bgMusic;
    private OrthographicCamera camera;

    public void create() {
        ship = new Texture(new FileHandle(new File("ship.png")));
        bg = new Texture(new FileHandle(new File("bg.png")));
        spriteBatch = new SpriteBatch();
        shipPosition.x = 480 / 2 - 320 / 2;
        fire = Gdx.audio.newSound(new FileHandle(new File("shoot.wav")));
        bgMusic = Gdx.audio.newMusic(new FileHandle(new File("bgmusic.mp3")));
        bgMusic.setVolume(0.2f);
        bgMusic.play();
        camera = new OrthographicCamera(480, 320);
        camera.position.set(480 / 2, 320 / 2, 0);

    }

    public void resize(int i, int i1) {
    }

    public void render() {
        camera.update();
        spriteBatch.setProjectionMatrix(camera.combined);

        Gdx.graphics.getGL10().glClear(GL10.GL_COLOR_BUFFER_BIT);

        // movement
        if (moveLeft) moveShip -= 0.2;
        else if (moveRight) moveShip += 0.2;
        else if (moveShip<0.2 && moveShip>-0.2) moveShip = 0;
        else if (moveShip>0) moveShip -= 0.2;
        else if (moveShip<0) moveShip += 0.2;

        if (shipPosition.x < 0 || shipPosition.x > 480 - 32)
                moveShip = moveShip *-1;

        // use of delta time here!
        shipPosition.x += moveShip * Gdx.graphics.getDeltaTime()*60;


        offset +=1; offset = offset%256;

        spriteBatch.begin();
        spriteBatch.setColor(Color.WHITE);

        for (int i = 0; i < Gdx.graphics.getWidth()/256+1; i++) {
            for (int j = 0; j < Gdx.graphics.getHeight()/256+2; j++) {
                spriteBatch.draw(bg, i*256, j*256-offset, 0, 0, bg.getWidth(),bg.getHeight());
            }
        }

        for (int i = 0; i < Gdx.graphics.getWidth()/64+1; i++) {
            for (int j = 0; j < Gdx.graphics.getHeight()/64+8; j++) {
                spriteBatch.draw(bg, i*64, j*64-offset*2, 0, 0, bg.getWidth()/4,bg.getHeight()/4);
            }
        }

        spriteBatch.draw(ship, shipPosition.x, shipPosition.y, 0, 0, ship.getWidth(),ship.getHeight());
        spriteBatch.end();
    }

    public void pause() {
    }

    public void resume() {
    }

    public void dispose() {
    }

    @Override
    public boolean keyDown(int keycode) {
        switch (keycode) {
            case Input.Keys.LEFT:
                moveLeft = true;
                break;
            case Input.Keys.RIGHT:
                moveRight = true;
                break;
            case Input.Keys.UP:
                fire.play();
                break;
            case Input.Keys.DOWN:
                break;
            case Input.Keys.SPACE:
                break;
            default:
                ;
        }
        return super.keyDown(keycode);
    }

    public boolean keyUp(int keycode) {
        switch (keycode) {
            case Input.Keys.LEFT:
                moveLeft = false;
                break;
            case Input.Keys.RIGHT:
                moveRight = false;
                break;
            case Input.Keys.UP:
                break;
            case Input.Keys.DOWN:
                break;
            case Input.Keys.SPACE:
                break;
            default:
                ;
        }
        return super.keyUp(keycode);
    }

    @Override
    public boolean touchDown(int x, int y, int pointer, int button) {

        return super.touchDown(x, y, pointer, button);
    }
}
